/* 
* Copyright (C) 2015, Adrian Jarabo (http://giga.cps.unizar.es/~ajarabo/)
*
* Permission is hereby granted, free of charge, to any person obtaining
* a copy of this software and associated documentation files (the "Software"),
* to deal in the Software without restriction, including without limitation
* the rights to use, copy, modify, merge, publish, distribute, sublicense,
* and/or sell copies of the Software, and to permit persons to whom
* the Software is furnished to do so, subject to the following conditions:

* The above copyright notice and this permission notice shall be included
* in all copies or substantial portions of the Software.

* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
* EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
* DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
* OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#ifndef _RADIANCE_SAMPLE_H_
#define _RADIANCE_SAMPLE_H_

#include "Color/Spectrum.h"

struct RadianceSample
{
	Spectrum radiance;
	Real distance;
	Real time; //picoseconds
	int bounce;
	Real camera_range; //camera spatial time range of radiance sample in 2D blur
	Real beam_range; //beam time range of radiance sample for beams 2D blur
	
	RadianceSample()
		:radiance(0), time(0), bounce(0), distance(0) {}
	RadianceSample(const Spectrum &_radiance, Real _time = 0., int _bounce = 0, Real _distance = 0):
		radiance(_radiance), time(_time), bounce(_bounce), distance(_distance){}
	
	RadianceSample(const Spectrum &_radiance, int _bounce, Real _distance = 0 ):
		radiance(_radiance), time(0.), bounce(_bounce), distance(_distance) {}
}; //RadianceSample

#endif //_RADIANCE_SAMPLE_H_